import sys
import copy

sudoku = []

# Copy one sudoku from https://github.com/dimitri/sudoku/blob/master/sudoku.txt into a file

f = open(sys.argv[1],'r') 
print("Loading the following sudoku: \n")

for fline in f:
    line = [int(d) for d in fline[:-1]]
    sudoku.append(line)
    print(line)

# sudoku now contains the input sudoku


def getConstraints(ps): # returns the set of lines, rows, and blocks
    constraints = copy.copy(ps) # All the lines 
    for j in range(9): # Extract column j
        row = []
        for i in range(9):
            row.append(ps[i][j])
        constraints.append(row)
    for i in range(3): 
        for j in range(3): # Extract the block (i,j)
            block = []
            for k in range(3):
                for l in range(3):
                    block.append(ps[3*i + k][3*j + l])
            constraints.append(block)
    return constraints

print("\nThe constraints are:\n")
for constr in getConstraints(sudoku):
    print(constr)


def firstUndefined(ps):
    'Returns the first position (i,j) containing a zero'
    pass


def noProblem(ps):
    '''Returns False if the partial sudoku ps contains a repeated number (not
    including 0) in a row, column or block, and True otherwise'''
    pass


def solveBruteforce(ps):
    '''Tries to solve the sudoku by going over all possible values for all the
    missing squares. We go over all possible assignments of the missing squares
    and we check wether the obtained full sudoku satisfies all the constraints'''
    pass


def solveUsingNondeterminism(ps):
    'Tries to solve the sudoku using the nondet package of Charles'
    pass


def solveBacktracking(ps):
    '''Tries to solve the sudoku using Backtracking. See the Wikipedia page on
    Backtracking (https://en.wikipedia.org/wiki/Backtracking#Pseudocode). The
    difference with bruteforce is that, instead of blindly going over all
    possible assignments of the missing values, we assign them one by one and
    we do not continue the exploration when the partial sudoku already violates
    a constraint'''
    pass


def solveUsingSATsolver(ps):
    '''Tries to solve the sudoku using the SAT solver PySAT
    (see https://pysathq.github.io/usage/ for how to use it)'''
    pass









